import matplotlib.pyplot as plt
import mplcursors
import numpy as np
import json
import P21
import P22
import P23
import P24
import P25
import P26
import P27

print("Taille de la P22", len(P22.L))
print("Taille de la P23", len(P23.L))
print("Taille de la P24", len(P24.L))
print("Taille de la P25", len(P25.L))
print("Taille de la P26", len(P26.L))
print("Taille de la P27", len(P27.L))

Promos = [P21.L, P22.L, P23.L, P24.L, P25.L, P26.L, P27.L]

Association = {}
Club = {}
Gens = []  # Tableau de la forme [Promo, Nb Asso, Nb Club, Nb groupe]

Promos = [P21.L, P22.L, P23.L, P24.L, P25.L, P26.L, P27.L]

max_asso_club = 0

# Liste des assos qu'on ne compte pas genre la FILCS

blacklist = ["Fédération de l'InterLocal de CentraleSupélec",
             "HumaCS", "Annonce CentraleSupélec", "CS Ultimate", "AS Basket M", "CS BasketBall", "Natation CS", "AS Basket F", "CentraleSupélec Boxe", "CRCF", "TopCSpin", "CSFC", "Escrime CS", "CS Karaté", "Cheer CS", "CS Equitation", "AS VTT", "Judo Club CentraleSupélec", "Waterpolo CS", "Club Badminton", "AS Athlé demi-fond", "CSHB", "Aviron CentraleSupélec Paris", "CentraleSupélec Football Club Féminin", "CRC", "CS VolleyBall", "CS Hockey", "AS Danse Moderne", "AS Tennis"]


# Asso de provinces
Assos_Metz = ["CoopéTM",
              "Rézo Metz-Rennes Fédérés (rm -rf)", "S&METZ", "Rézo Metz", "BDE CentraleSupélec Campus de Metz", "BDS Metz", "FéniCS", "CLUB SANDWICH", "Impact CentraleSupélec Metz", "Bureau des Arts - campus de Metz", "Magnum Metz", "BdI Metz", "BDA Metz"]
Assos_Rennes = ["BDE CentraleSupélec Campus de Rennes",
                "Rock CentraleSupélec Rennes", "BDS Rennes", "Supélec Rézo Rennes", "C3Pélec", "Festnoz", "Breizh BreaCS", "NEWTON", "DisCS", "Supélec Stunt", "Poulet Breizh'é", "OrnithorynCS", "Grand Cru Supélec", "ARTémics", "Rennes 2 Pique", "ReNX", "Burofoot", "Distenn", "BdI Rennes", "Kafédis"]
Acitfs_Assos_Provinces = {21: {'Metz': 0, 'Rennes': 0}, 22: {'Metz': 0, 'Rennes': 0}, 23: {'Metz': 0, 'Rennes': 0}, 24: {
    'Metz': 0, 'Rennes': 0}, 25: {'Metz': 0, 'Rennes': 0}, 26: {'Metz': 0, 'Rennes': 0}, 27: {'Metz': 0, 'Rennes': 0}}


# L'idée est de traiter la liste des gens pour avoir la liste des types de personnes dans une promo, d'avoir le nombre de gens dans chaque asso par promo
for Liste in range(len(Promos)):
    for personne in Promos[Liste]:
        Actif_Metz = False
        Actif_Rennes = False
        description = [21+Liste, 0, 0, 0]
        for groupe in personne["memberships"]:
            if groupe["association"]["name"] not in blacklist:
                if groupe["association"]["type"] == "ASSOCIATION":
                    description[1] += 1
                    if groupe["association"]["name"] in Association.keys():
                        Association[groupe["association"]
                                    ["name"]][21+Liste] += 1
                    else:
                        Association[groupe["association"]["name"]] = {21: 0,
                                                                      22: 0, 23: 0, 24: 0, 25: 0, 26: 0, 27: 0}
                        Association[groupe["association"]
                                    ["name"]][21+Liste] = 1
                    if (not (Actif_Metz)) and (groupe["association"]["name"] in Assos_Metz):
                        Actif_Metz = True
                        Acitfs_Assos_Provinces[21+Liste]['Metz'] += 1
                    if (not (Actif_Rennes)) and (groupe["association"]["name"] in Assos_Rennes):
                        Actif_Rennes = True
                        Acitfs_Assos_Provinces[21+Liste]['Rennes'] += 1

                elif groupe["association"]["type"] == "CLUB" and (groupe["association"]["name"] not in blacklist):
                    description[2] += 1
                    if groupe["association"]["name"] in Club.keys():
                        Club[groupe["association"]["name"]][21+Liste] += 1
                    else:
                        Club[groupe["association"]["name"]] = {21: 0,
                                                               22: 0, 23: 0, 24: 0, 25: 0, 26: 0, 27: 0}
                        Club[groupe["association"]["name"]][21+Liste] = 1
                    if (not (Actif_Metz)) and (groupe["association"]["name"] in Assos_Metz):
                        Actif_Metz = True
                        Acitfs_Assos_Provinces[21+Liste]['Metz'] += 1
                    if (not (Actif_Rennes)) and (groupe["association"]["name"] in Assos_Rennes):
                        Actif_Rennes = True
                        Acitfs_Assos_Provinces[21+Liste]['Rennes'] += 1
                elif groupe["association"]["type"] == "GROUPE":
                    description[3] += 1
                else:
                    print(groupe["association"]["type"])
        Gens.append(description)

print("Nb gens :", len(Gens))
print("Nb asso :", len(Association))
print("Nb club :", len(Club))
print("Contribution Province", Acitfs_Assos_Provinces)
print(Association["Espérance en Béton"])

# Nombre de DarkCS

DarkCS = {21: 0, 22: 0, 23: 0, 24: 0, 25: 0, 26: 0, 27: 0}
Asso_club = {}

for personne in Gens:
    if personne[1]+personne[2] == 0:
        DarkCS[personne[0]] += 1
    if (personne[1], personne[2]) in Asso_club.keys():
        Asso_club[(personne[1], personne[2])][personne[0]] += 1
    else:
        Asso_club[(personne[1], personne[2])] = {21: 0,
                                                 22: 0, 23: 0, 24: 0, 25: 0, 26: 0, 27: 0}
        Asso_club[(personne[1], personne[2])][personne[0]] += 1

print(DarkCS)
L = []
for i in range(len(Promos)):
    L.append(DarkCS[i+21])
plt.plot(range(21, len(L)+21), L)
plt.xlabel("Promotion")
plt.ylabel("Nombre de personne sans association")
#plt.show()

# Le nombre
for promo in range(len(Promos)):
    data = [[Asso_club[(i, j)][promo+21] for j in range(6)] for i in range(6)]

    # Affichage du pavage
    plt.imshow(data, cmap='viridis', interpolation='nearest')
    plt.colorbar(label="Nombre de personne")

    plt.xticks(range(6))
    plt.yticks(range(6))

    plt.xlabel("Nombre d'association")
    plt.ylabel("Nombre de club")

    # Afficher la grille
    plt.grid(visible=True, color='black', linewidth=1)
    plt.title("Promo 20"+str(promo+21))
    plt.show()

# La différence
for promo in range(len(Promos)-1):
    data = [[Asso_club[(i, j)][promo+21]-Asso_club[(i, j)][promo+21+1]
             for j in range(6)] for i in range(6)]

    # Affichage du pavage
    #plt.imshow(data, cmap='viridis', interpolation='nearest')
    plt.colorbar(label="Evolution du nombre de personnes")

    plt.xticks(range(6))
    plt.yticks(range(6))

    plt.xlabel("Nombre d'association")
    plt.ylabel("Nombre de club")

    # Afficher la grille
    plt.grid(visible=True, color='black', linewidth=1)
    plt.title("Promo 20"+str(promo+21)+" - 20"+str(promo+22+1))
    #plt.show()

    # Histogramme de la province

    # Années et villes
years = list(Acitfs_Assos_Provinces.keys())


metz_values = [Acitfs_Assos_Provinces[year]['Metz'] for year in years]
rennes_values = [Acitfs_Assos_Provinces[year]['Rennes'] for year in years]

# Position des barres
x = np.arange(len(years))  # Positions des années
width = 0.35  # Largeur des barres

# Création de l'histogramme
fig, ax = plt.subplots(figsize=(10, 6))

# Tracer les barres pour Metz et Rennes
bars_metz = ax.bar(x - width/2, metz_values, width, label='Metz', color='blue')
bars_rennes = ax.bar(x + width/2, rennes_values, width,
                     label='Rennes', color='green')

# Ajouter des labels et un titre
ax.set_xlabel('Année')
ax.set_ylabel('Nombre de gens')
ax.set_title('Nombre de gens par année et ville')
ax.set_xticks(x)
ax.set_xticklabels(years)
ax.legend()

# Afficher l'histogramme
plt.tight_layout()
#plt.show()


plt.figure()
for association in Association.keys():
    for year in Association[association].keys():
        plt.plot(year, Association[association][year], 'o', label=association)
mplcursors.cursor(hover=True)
#plt.show()

with open('Clubs.json','w') as f:
    json.dump(Club, f, indent=4, ensure_ascii=False)

