import React, { useState } from 'react';
import DropdownMenu from './menu';
import Chart from './test_graph';

const ParentComponent = () => {
    const [selectedItems, setSelectedItems] = useState([]);
    const handleAssociationChange = (updatedAssociations) => {
        setSelectedItems(updatedAssociations);
      };
    return (
        <div>
            <DropdownMenu onChange={handleAssociationChange} />
            <Chart associations={selectedItems} />
        </div>

    );
};

export default ParentComponent;